Subject: Re: [PATCH 7/9] net: add skb_orphan_frags to copy aside frags with destructors

From: "Michael S. Tsirkin" <[email-masked]>
Date: Sun, 6 May 2012 20:01:56 +0300

On Fri, May 04, 2012 at 02:54:33AM -0400, David Miller wrote:
> From: "Michael S. Tsirkin" <[email-masked]>
> Date: Fri, 4 May 2012 00:10:24 +0300
> 
> > Hmm we orphan skbs when we loop them back so how about reusing the
> > skb->destructor for this?
> 
> That's one possibility.
> 
> But I fear we're about to toss Ian into yet another rabbit hole. :-)
> 
> Let's try to converge on something quickly as I think integration of
> his work has been delayed enough as-is.

OK I tried doing this and I recalled why we
do the copy with ubufs before clone:
the problem is that shinfo is shared between skbs,
so modifying frags like skb_orphan_frags does is racy.
Stuck for now.

So I have a question: how about reusing the TX_DEV_ZEROCOPY
machinery for this, instead of frag destructors?

Thanks,

-- 
MST